/*
*  Licensed Materials - Property of IBM
*  5725-G92 (C) Copyright IBM Corp. 2006, 2012. All Rights Reserved.
*  US Government Users Restricted Rights - Use, duplication or
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

window.$ = WLJQ;
var busyIndicator = null;
var citiesList = null;

function wlCommonInit() {
	busyIndicator = new WL.BusyIndicator("AppBody");
	$('#citiesList').change(citySelectionChange);
	getCitiesList();
}

function getCitiesList() {
	busyIndicator.show();
	var invocationData = {
		adapter : 'SQLAdapter',
		procedure : 'getCitiesWeather',
		parameters : []
	};

	WL.Client.invokeProcedure(invocationData, {
		onSuccess : getCitiesListSuccess,
		onFailure : getCitiesListFailure
	});
}

function getCitiesListSuccess(response) {
	if (response.invocationResult.resultSet.length == 0)
		getCitiesListFailure();
	else {
		citiesList = response.invocationResult.resultSet;
		fillCitiesList();
	}
}

function getCitiesListFailure(response) {
	WL.Logger.debug("CityWeather::getCitiesListFailure");
	busyIndicator.hide();
	WL.SimpleDialog.show("CityWeather",
			"Can't get cities list. Check database connection", [ {
				text : 'Reload app',
				handler : WL.Client.reloadApp
			} ]);
}

function fillCitiesList(){
	$('#citiesList').empty();
	for (var i = 0; i < citiesList.length; i++) {
		var elem = $("<option/>").html(citiesList[i].city);		
		$('#citiesList').append(elem);
	}
	busyIndicator.hide();
	citySelectionChange();
}

function citySelectionChange() {
	var index = $('#citiesList').prop("selectedIndex");
	var citySumm = citiesList[index].summary;
	var cityWeather = citiesList[index].weather;
	$('#info').html(cityWeather + "<br>" + citySumm.slice(0, 200) + "...");
}